Leetcode 3490. Count Beautiful Numbers

  • [Leetcode 3490. Count Beautiful Numbers](#Leetcode 3490. Count Beautiful Numbers)
    • [1. 解题思路](#1. 解题思路)
    • [2. 代码实现](#2. 代码实现)

1. 解题思路

这道题能够自力搞定还是蛮开心的。

这道题主体的思路其实很清晰,就是将题目变换一下,变成写作一个count(n)函数来求取不大于数字 n n n的全部beautiful number的数目,这样,原始问题的答案就变成了count(r) - count(l-1)。因此,我们只需要考察这个count函数的实现即可,不过到这里其实也没怎么简化问题也就是了。

问题的关键在于这里这个beautiful number的定义,他是说其各个位上所有数的积能够被其各个位上的所有数的和整除。而题目中限制 n ≤ 1 0 9 n \leq 10^9 n≤109,因此事实上最大的数也就是 999999999 999999999 999999999,各个位上的digit的和最大也就是 81 81 81,因此,我们就可以变换命题为:

  • 求出所有不大于 n n n,且其各个位上的数字之和等于 k k k,且其积能够被 k k k整除的数的个数。

遍历 k k k从 1 1 1到 81 81 81,即可求出不大于 n n n的所有beautiful number的个数。

因此,命题最终也就变成了:

  • 求出所有不大于 n n n,且其各个位上的数字之和等于 k k k,且其积能够被 k k k整除的数的个数。

对于这个问题,我们就可以将其转换为一个动态规划的问题了,就是考察其每一个位上的数据的取值,然后考察其和以及积的变化即可。唯一需要注意的是:

  • 开头的0不能被计算到乘积当中,否则其就总是可以被 k k k整除了;
  • 需要考察当前位上的数的取值能否超过 n n n上的同一位置的数,即,如果两者之前的数均相同,那么当前位上的数取值不能超过 n n n上的同一位置的数。

2. 代码实现

给出最终的python代码实现如下:

python 复制代码
class Solution:
    def beautifulNumbers(self, l: int, r: int) -> int:
        
        def count_beatiful_numbers(num):
            if num <= 10:
                return num
            
            num_str = str(num)
            n = len(num_str)
            
            @lru_cache(None)
            def dp(idx, _sum, _prod, allow_larger, is_all_leading_zeros):
                if idx >= n:
                    return 1 if _sum == 0 and _prod == 1 else 0
                elif _sum == 0:
                    return 1
                elif 9 * (n-idx) < _sum:
                    return 0
                
                if allow_larger:
                    ans = 0
                    if is_all_leading_zeros:
                        ans += dp(idx+1, _sum, _prod, allow_larger, True)
                        for i in range(1, min(10, _sum+1)):
                            ans += dp(idx+1, _sum-i, _prod // gcd(_prod, i), True, False)
                    else:
                        for i in range(min(10, _sum+1)):
                            ans += dp(idx+1, _sum-i, _prod // gcd(_prod, i), True, False)
                else:
                    digit = int(num_str[idx])
                    ans = 0
                    if is_all_leading_zeros:
                        if digit == 0:
                            ans += dp(idx+1, _sum, _prod, False, True)
                        else:
                            ans += dp(idx+1, _sum, _prod, True, True)
                        for i in range(1, min(digit, _sum+1)):
                            ans += dp(idx+1, _sum-i, _prod // gcd(_prod, i), True, False)
                        if digit != 0 and digit <= _sum:
                            ans += dp(idx+1, _sum-digit, _prod // gcd(_prod, digit), False, False)
                    else:
                        for i in range(min(digit, _sum+1)):
                            ans += dp(idx+1, _sum-i, _prod // gcd(_prod, i), True, False)
                        if digit <= _sum:
                            ans += dp(idx+1, _sum-digit, _prod // gcd(_prod, digit), False, False)
                return ans
            
            ans = 0
            for i in range(1, 82):
                ans += dp(0, i, i, False, True)
            return ans
        
        return count_beatiful_numbers(r) - count_beatiful_numbers(l-1)

提交代码评测得到:耗时637ms,占用内存64.6MB。

相关推荐
richard_yuu1 天前
动态规划:强化学习的「数学基础」,从 MDP 到值迭代
深度学习·神经网络·算法·yolo·机器学习·动态规划
lvwangshu2 天前
P12960 毒药 题解
动态规划·题解·贪心·技巧·性质题·思维好题
彧azz9 天前
算法设计与分析:贪心与动态规划
数据结构·学习·算法·贪心算法·动态规划
Logic10110 天前
C语言/数据结构动态规划题解:Kadane算法求最大子数组和——O(n)时间O(1)空间
c语言·数据结构·动态规划·贪心·时间复杂度·算法题·最大子数组和
梦帮科技11 天前
AI 音乐产品的发布工程:验证门、数据发布、回滚与生产运维纪律
数据结构·数据库·架构·node.js·音视频·动态规划·推荐算法
语戚11 天前
力扣 1621. 大小为K的不重叠线段的数目:动态规划(Java 实现)
java·算法·leetcode·动态规划·力扣·dp
青山木11 天前
Hot 100 --- 最长有效括号
java·数据结构·算法·leetcode·动态规划
这料鬼有毒11 天前
二刷hot100-1143.最长公共子序列
算法·leetcode·动态规划
Tisfy12 天前
LeetCode 1477.找两个和为目标值且不重叠的子数组:滑动窗口 + 记录前值(动态规划)
动态规划·题解·dp·滑动窗口
ynchyong12 天前
动态规划解题思路:入门篇
动态规划